package com.ccnode.codegenerator.mybatisGenerator.plugins;

package .tmp;

import com.ccnode.codegenerator.mybatisGenerator.plugins.tools.FormatTools;
import com.ccnode.codegenerator.mybatisGenerator.plugins.tools.JavaElementGeneratorTools;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;
import org.mybatis.generator.api.IntrospectedColumn;
import org.mybatis.generator.api.IntrospectedTable;
import org.mybatis.generator.api.PluginAdapter;
import org.mybatis.generator.api.dom.java.FullyQualifiedJavaType;
import org.mybatis.generator.api.dom.java.Interface;
import org.mybatis.generator.api.dom.java.JavaVisibility;
import org.mybatis.generator.api.dom.java.Method;
import org.mybatis.generator.api.dom.java.Parameter;
import org.mybatis.generator.api.dom.java.TopLevelClass;
import org.mybatis.generator.api.dom.xml.Attribute;
import org.mybatis.generator.api.dom.xml.Document;
import org.mybatis.generator.api.dom.xml.Element;
import org.mybatis.generator.api.dom.xml.TextElement;
import org.mybatis.generator.api.dom.xml.XmlElement;
import org.mybatis.generator.codegen.mybatis3.ListUtilities;
import org.mybatis.generator.codegen.mybatis3.MyBatis3FormattingUtilities;
import org.mybatis.generator.internal.util.StringUtility;

public class UpdateBatchPlugin2UseMultiQueries extends PluginAdapter {
  private FullyQualifiedJavaType a;
  
  private String a;
  
  public UpdateBatchPlugin2UseMultiQueries() {
    this.a = (String)new FullyQualifiedJavaType("java.util.List");
    this.a = "updateBatch";
  }
  
  public boolean validate(List<String> paramList) {
    return true;
  }
  
  public boolean sqlMapDocumentGenerated(Document paramDocument, IntrospectedTable paramIntrospectedTable) {
    if (paramIntrospectedTable.hasPrimaryKeyColumns()) {
      XmlElement xmlElement1 = paramDocument.getRootElement();
      XmlElement xmlElement2 = new XmlElement("update");
      xmlElement2.getAttributes().add(0, new Attribute("id", this.a));
      xmlElement2.getAttributes().add(new Attribute("parameterType", "java.util.List"));
      getContext().getCommentGenerator().addComment(xmlElement2);
      XmlElement xmlElement3 = new XmlElement("foreach");
      xmlElement3.getAttributes().add(0, new Attribute("collection", "list"));
      xmlElement3.getAttributes().add(1, new Attribute("item", "item"));
      xmlElement3.getAttributes().add(2, new Attribute("separator", ";"));
      StringBuilder stringBuilder = new StringBuilder();
      stringBuilder.append("update ");
      stringBuilder.append(paramIntrospectedTable.getFullyQualifiedTableNameAtRuntime());
      xmlElement3.addElement((Element)new TextElement(stringBuilder.toString()));
      XmlElement xmlElement4 = new XmlElement("set");
      xmlElement3.addElement((Element)xmlElement4);
      Iterator<IntrospectedColumn> iterator1 = ListUtilities.removeGeneratedAlwaysColumns(paramIntrospectedTable.getNonPrimaryKeyColumns()).iterator();
      while (iterator1.hasNext()) {
        IntrospectedColumn introspectedColumn = iterator1.next();
        XmlElement xmlElement = a(introspectedColumn, "item.");
        xmlElement4.addElement((Element)xmlElement);
        stringBuilder.setLength(0);
        stringBuilder.append(MyBatis3FormattingUtilities.getEscapedColumnName(introspectedColumn));
        stringBuilder.append(" = ");
        stringBuilder.append(MyBatis3FormattingUtilities.getParameterClause(introspectedColumn, "item."));
        stringBuilder.append(',');
        xmlElement.addElement((Element)new TextElement(stringBuilder.toString()));
      } 
      boolean bool = false;
      Iterator<IntrospectedColumn> iterator2 = paramIntrospectedTable.getPrimaryKeyColumns().iterator();
      while (iterator2.hasNext()) {
        IntrospectedColumn introspectedColumn = iterator2.next();
        stringBuilder.setLength(0);
        if (bool) {
          stringBuilder.append("  and ");
        } else {
          stringBuilder.append("where ");
          bool = true;
        } 
        stringBuilder.append(MyBatis3FormattingUtilities.getEscapedColumnName(introspectedColumn));
        stringBuilder.append(" = ");
        stringBuilder.append(MyBatis3FormattingUtilities.getParameterClause(introspectedColumn, "item."));
        xmlElement3.addElement((Element)new TextElement(stringBuilder.toString()));
      } 
      xmlElement2.addElement((Element)xmlElement3);
      xmlElement1.addElement((Element)xmlElement2);
    } 
    return super.sqlMapDocumentGenerated(paramDocument, paramIntrospectedTable);
  }
  
  public static XmlElement a(IntrospectedColumn paramIntrospectedColumn, String paramString) {
    XmlElement xmlElement = new XmlElement("if");
    StringBuilder stringBuilder = new StringBuilder();
    stringBuilder.append(paramString + paramString);
    stringBuilder.append(" != null");
    String str = paramIntrospectedColumn.getContext().getProperty("checkEmptyForString");
    if (StringUtility.stringHasValue(str) && str.equalsIgnoreCase("true") && paramIntrospectedColumn.getFullyQualifiedJavaType().getFullyQualifiedName().equals("java.lang.String"))
      stringBuilder.append(" and " + paramString + paramIntrospectedColumn.getJavaProperty() + " != ''"); 
    xmlElement.addAttribute(new Attribute("test", stringBuilder.toString()));
    return xmlElement;
  }
  
  public boolean clientGenerated(Interface paramInterface, TopLevelClass paramTopLevelClass, IntrospectedTable paramIntrospectedTable) {
    if (paramIntrospectedTable.hasPrimaryKeyColumns()) {
      FullyQualifiedJavaType fullyQualifiedJavaType = new FullyQualifiedJavaType(this.a.getShortName());
      fullyQualifiedJavaType.addTypeArgument(JavaElementGeneratorTools.a(paramIntrospectedTable));
      Method method = JavaElementGeneratorTools.a(this.a, JavaVisibility.DEFAULT, 

          
          FullyQualifiedJavaType.getIntInstance(), new Parameter[] { new Parameter(fullyQualifiedJavaType, "list", "@Param(\"list\")") });
      method.setReturnType(new FullyQualifiedJavaType("int"));
      paramInterface.addImportedType((FullyQualifiedJavaType)this.a);
      FormatTools.a(paramInterface, method);
    } 
    return super.clientGenerated(paramInterface, paramTopLevelClass, paramIntrospectedTable);
  }
  
  private String a(IntrospectedColumn paramIntrospectedColumn, boolean paramBoolean) {
    StringBuilder stringBuilder = new StringBuilder();
    stringBuilder.append(paramIntrospectedColumn.getActualColumnName());
    stringBuilder.append(" = ");
    if (paramBoolean) {
      stringBuilder.append("#{");
    } else {
      stringBuilder.append("#{item.");
    } 
    stringBuilder.append(paramIntrospectedColumn.getJavaProperty());
    stringBuilder.append(",jdbcType=");
    stringBuilder.append(paramIntrospectedColumn.getJdbcTypeName());
    stringBuilder.append("}");
    return stringBuilder.toString();
  }
  
  public void setProperties(Properties paramProperties) {
    super.setProperties(paramProperties);
    String str = paramProperties.getProperty("updateBatch");
    if (StringUtility.isTrue(str))
      this.a = "updateBatchUseMultiQuery"; 
  }
  
  private String b(IntrospectedColumn paramIntrospectedColumn, boolean paramBoolean) {
    if (paramBoolean)
      return MyBatis3FormattingUtilities.getParameterClause(paramIntrospectedColumn, null); 
    return MyBatis3FormattingUtilities.getParameterClause(paramIntrospectedColumn, "item.");
  }
}
